10  REM  *********************************
11  REM  **    APPLE *S*T*A*R* SYSTEM   **
12  REM  **   (INFORMATION STORAGE AND  **
13  REM  **       RETRIEVAL SYSTEM)     **
14  REM  **        BY MARK CAPELLA      **
15  REM  **    COPYRIGHT (C) 1981 BY    **
16  REM  **       MICRO-SPARC, INC.     **
17  REM  **      LINCOLN, MA. 01773     **
18  REM  *********************************
60  REM 
65  REM  REQUIRES 48K APPLE II OR APPLE II PLUS, APPLESOFT IN ROM, AND 1 DISK
100  REM  *** MAIN ROUTINE
125  GOSUB 1000: REM  MAIN TITLES
130  GOSUB 2000: REM  SETUP
135  GOSUB 3000: REM  MAIN PROGRM
140  GOSUB 4000: REM  SHUTDOWN
145  END 
1000  REM  *** SPLASH PAGE AND
1005  REM  *** DEBUGGING AIDS
1030  LET TRUE = 1
1035  LET FALSE = 0
1040  LET VIDEO = TRUE
1045  LET NOSIG = FALSE
1050  LET TESTING = FALSE
1051  LET DOS$ =  CHR$(4)
1052  ONERR  GOTO 30000
1060  REM 
1065  IF VIDEO  THEN  TEXT : HOME : NORMAL 
1070  IF NOSIG  THEN 1110
1075  VTAB 3: HTAB 8: PRINT "*************************": PRINT 
1080  HTAB 10: PRINT "APPLE ";: FLASH : PRINT "ST.A.R.";: NORMAL : PRINT " SYSTEM": PRINT 
1085  HTAB 8: PRINT "(STORAGE AND RETRIEVAL)"
1090  HTAB 12: PRINT "BY MARK CAPELLA ": PRINT 
1095  HTAB 9: PRINT "COPYRIGHT (C) 1981 BY": PRINT 
1100  HTAB 11: PRINT "MICRO-SPARC, INC."
1105  VTAB 15: HTAB 8: PRINT "*************************": PRINT 
1110  RETURN 
2000  REM  *** SETUP ROUTINE
2021 BL$ = "                                   "
2022 BL$ = BL$ +BL$ +BL$ +BL$ +BL$ +BL$ +BL$
2025  DIM FI$(50): REM  FIELD
2030  DIM FL$(50): REM  LENGTH
2045  LET NF = 0: REM  # FIELDS
2050  DIM RE$(50): REM  EXTRAS
2052 MR = 500
2055  DIM ID$(MR): REM  INDEXS
2060  LET NI = 0: REM  # INDEXS
2062  DIM TF(50): REM  TEMP FLDS
2063  DIM GT(50,2): REM  TOTALS
2065  REM 
2067  VTAB 23: INPUT "WHAT FILE WILL YOU BE USING : ";F$: IF F$ = ""  THEN 2067
2070  REM 
2075  GOSUB 17000: REM  INIT
2080  GOSUB 2100: REM  HEADERS
2082 IL = 1 + VAL(FL$(1)) +(2 *(NF -1)) +4 +1
2085  GOSUB 2200: REM  INDEXES
2095  RETURN 
2100  REM  *** GET HEADER STUFF
2125  IF TESTING  THEN  PRINT "HEADER READ..."
2130 RL = 0
2132 NF = 0: REM  START READ
2135  PRINT DOS$"OPEN "F$"@HEADER"
2140  PRINT DOS$"READ "F$"@HEADER"
2145 ERR = 0: IF   NOT ERR  THEN  INPUT FI$: GOTO 2155
2150  PRINT DOS$"CLOSE "F$"@HEADER": RETURN 
2155 NF = NF +1:FI$(NF) = FI$
2160  INPUT FL$(NF):RL = RL + VAL(FL$(NF)): GOTO 2145
2200  REM  *** GET RECORD INDEXS
2222  IF TESTING  THEN  PRINT "INDEXS READ..."
2225 ERR = 0: IF   NOT ERR  THEN  PRINT DOS$"OPEN "F$"@INDEXES,L"IL
2230  PRINT DOS$"READ "F$"@INDEXES,R1"
2235 ERR = 0: IF   NOT ERR  THEN  INPUT ID$: GOTO 2245
2240  PRINT DOS$"CLOSE "F$"@INDEXES": RETURN 
2245 NI = NI +1:ID$(NI) = ID$: GOTO 2235
3000  REM 
3010  REM  *** MAIN PROGRAM LOOP
3015  REM  *** HERE WE GET THE
3020  REM  *** COMMAND AND THEN
3025  REM  *** ACT ON IT
3050  GOSUB 5000: REM  MAIN MENU
3055  REM 
3060  GOSUB 6000: REM  DECIPHER
3065  GOTO 3050
4000  REM  *** SHUTDOWN
4097  GOSUB 1065: REM  DO TITLES
4100  PRINT DOS$"CLOSE"
4998  VTAB 21: PRINT "ASARM RUN COMPLETE."
4999  END 
5000  REM  *** MAIN MENU
5025  IF VIDEO  THEN  TEXT : HOME : NORMAL 
5030  VTAB 1: PRINT "THE FOLLOWING OPTIONS ARE AVAILABLE : ": PRINT : PRINT 
5032  PRINT "      SHOW) SHOW THE RECORD LAYOUT": PRINT 
5035  PRINT "     ENTER) ENTER A DATA RECORD"
5040  PRINT "    DELETE) DELETE A DATA RECORD"
5045  PRINT "    MODIFY) MODIFY A DATA RECORD"
5050  PRINT "   DISPLAY) DISPLAY A DATA RECORD"
5052  PRINT "   RECOVER) RECOVER A DELETED RECORD"
5055  PRINT : PRINT "      LIST) LIST A SERIES OF RECORDS"
5057  PRINT "     DLIST) LIST ONLY DELETED RECORDS"
5060  PRINT "     PRINT) PRINT A SERIES OF RECORDS"
5061  PRINT "    DPRINT) PRINT ONLY DELETED RECORDS"
5062  PRINT : PRINT "      SORT) SORT THE RECORDS BY KEY"
5063  PRINT "    SEARCH) SEARCH FOR A RECORD"
5065  PRINT : PRINT "      STOP) STOP PROCESSING"
5075  VTAB 23: CALL  -868: INPUT "WHICH DO YOU WISH : ";RESPNSE$
5076  IF RE$ = ""  THEN 5075
5080 RE$ =  LEFT$(RE$,3): IF RE$ = "ENT"  OR RE$ = "DEL"  OR RE$ = "MOD"  OR RE$ = "DIS"  OR RE$ = "SOR"  OR RE$ = "LIS"  OR RE$ = "PRI"  OR RE$ = "STO"  OR RE$ = "REC"  OR RE$ = "SHO"  THEN  RETURN 
5081  IF RE$ = "DLI"  OR RE$ = "DPR"  OR RE$ = "SEA"  THEN  RETURN 
5085  VTAB 23: CALL  -868: PRINT "<<< THAT IS NOT ONE OF THE CHOICES >>>": FOR PAUSE = 1 TO 1500: NEXT PAUSE: GOTO 5075
6000  REM  *** COMMAND SWITCHING
6025  IF RE$ = "ENT"  THEN 10000: RETURN 
6035  IF RE$ = "DEL"  THEN 11000: RETURN 
6045  IF RE$ = "DIS"  THEN 12000: RETURN 
6055  IF RE$ = "MOD"  THEN 13000: RETURN 
6065  IF RE$ = "LIS"  THEN 14000: RETURN 
6066  IF RE$ = "DLI"  THEN 14000: RETURN 
6075  IF RE$ = "PRI"  THEN 14000: RETURN 
6076  IF RE$ = "DPR"  THEN 14000: RETURN 
6085  IF RE$ = "REC"  THEN 15000: RETURN 
6095  IF RE$ = "SHO"  THEN 16000: RETURN 
6105  IF RE$ = "SOR"  THEN 19000: RETURN 
6107  IF RE$ = "SEA"  THEN 20000: RETURN 
6115  IF RE$ = "STO"  THEN  POP : RETURN 
6125  RETURN 
10000  REM  *** ENTER RECORD
10025  IF VIDEO  THEN  TEXT : HOME : NORMAL 
10030  GOSUB 10100: REM  GET REC#
10032  IF RN >MR  THEN  VTAB 23: INPUT "THERE IS NO MORE MEMORY SPACE AVAILABLE FOR YOU TO STORE RECORDS. HIT RETURN    WHEN YOU ARE READY TO CONTINUE : ";RE$: RETURN 
10035  GOSUB 10200: REM  ENTER IT
10036  IF I = 1  AND RE$(I) = ""  THEN  RETURN 
10037  GOSUB 10300: REM  DISPLAY
10040  IF RE$ = "Y"  THEN  GOSUB 10400: REM  OUTPUT IT
10050  GOTO 10025
10100  REM  *** GET A RECORD#
10115  REM  *** TO ENTER DATA
10130  IF NI = 0  THEN 10150
10135  FOR I = 1 TO NI
10140  IF  LEFT$(ID$(I),1) = "/"  THEN RN =  VAL( RIGHT$(ID$(I),4)):IN = I: RETURN 
10145  NEXT 
10150 RN = NI +1:IN = RN: RETURN 
10200  REM  *** ENTER INFO
10205  REM 
10225  IF VIDEO  THEN  TEXT : HOME : NORMAL 
10230  VTAB 1: PRINT "<<< ENTERING RECORD "RN" >>>": VTAB 5
10235  FOR I = 1 TO NF
10240  PRINT FI$(I)": ";: FOR J = 1 TO  VAL(FL$(I)): PRINT  CHR$(95);: NEXT : FOR J = 1 TO  VAL(FL$(I)): PRINT  CHR$(8);: NEXT : INPUT "";RE$(I)
10241  IF I = 1  AND RE$(I) = ""  THEN  RETURN 
10245  IF  LEN(RE$(I)) > VAL(FL$(I))  THEN 10240
10250  IF  LEN(RE$(I)) < VAL(FL$(I))  THEN RE$(I) = RE$(I) + LEFT$(BL$, VAL(FL$(I)) - LEN(RE$(I)))
10255  NEXT I
10265  RETURN 
10300  REM  *** REPRINT RECORD
10325  TEXT : HOME 
10330  VTAB 1: PRINT "<<< THE FOLLOWING INFO WAS ENTERED >>>"
10335  VTAB 5: FOR I = 1 TO NF: PRINT FI$(I)": "RE$(I): NEXT 
10340  VTAB 22: CALL  -958: INPUT "IS THIS CORRECT : ";RE$:RE$ =  LEFT$(RE$,1): IF RE$ < >"Y"  AND RE$ < >"N"  THEN  PRINT "": GOTO 10340
10345  RETURN 
10400  REM  *** DATA IS OK
10423 ERR = 0: IF   NOT ERR  THEN  PRINT DOS$"OPEN "F$"@DATA,L"RL +1: GOTO 10425
10424  VTAB 23: CALL  -958: PRINT "THERE IS NO MORE ROOM FOR DATA": FOR PA = 1 TO 1000: NEXT PA: GOTO 10999
10425  PRINT DOS$"WRITE "F$"@DATA,R"RN
10430  FOR I = 1 TO NF
10432 ERR = 0: IF   NOT ERR  THEN  PRINT RE$(I);: GOTO 10434
10433  VTAB 23: CALL  -958: PRINT "THERE IS NO MORE ROOM ON DISK...": FOR PA = 1 TO 1000: NEXT PA: PRINT DOS$"CLOSE "F$"@DATA": GOTO 10999
10434  NEXT I: PRINT 
10435  PRINT DOS$"CLOSE "F$"@DATA"
10440  IF RN >NI  THEN NI = RN
10445 ID$(IN) = ">" +RE$(1): IF NF >1  THEN  FOR I = 2 TO NF:ID$(IN) = ID$(IN) + LEFT$(RE$(I) +" ",2): NEXT 
10447 ID$(IN) = ID$(IN) + RIGHT$("0000" + STR$(RN),4)
10450  PRINT DOS$"CLOSE "F$"@DATA"
10460 ERR = 0: IF   NOT ERR  THEN  PRINT DOS$"OPEN "F$"@INDEXES,L"IL: GOTO 10463
10461  VTAB 23: CALL  -958: PRINT "THERE IS NO MORE ROOM FOR DATA...": FOR PA = 1 TO 1000: NEXT PA: GOTO 10999
10463  IF TESTING  THEN  PRINT "INDEX : "IL: PRINT "RN = "IN
10465  PRINT DOS$"WRITE "F$"@INDEXES,R"IN
10470 ERR = 0: IF   NOT ERR  THEN  PRINT ID$(IN): GOTO 10475
10472  VTAB 23: CALL  -958: PRINT "THERE IS NO MORE ROOM FOR DATA...": FOR PA = 1 TO 1000: NEXT PA
10475  PRINT DOS$"CLOSE "F$"@INDEXES"
10999  RETURN 
11000  REM  *** DELETE RECORD
11025  GOSUB 12100: REM  GET REC#
11030  IF RE$ = ""  THEN  RETURN 
11035  GOSUB 12200: REM  FIND IT
11040  IF   NOT FO  THEN 11025
11042 IN = FO:FO =  VAL( RIGHT$(ID$(FO),4))
11045  GOSUB 12300: REM  GET IT
11050  GOSUB 12400: REM  DISPLAY
11055  VTAB 23: CALL  -868: INPUT "TYPE DELETE OR RETURN TO ABORT : ";RE$
11060  IF RE$ < >"DELETE"  THEN 11025
11065 ID$(IN) = "/" + MID$ (ID$(IN),2): GOSUB 10460
11999  GOTO 11025
12000  REM  *** DISPLAY RECORD
12030  GOSUB 12100: REM  GET REC#
12031  IF RE$ = ""  THEN  RETURN 
12035  GOSUB 12200: REM  FIND IT
12040  IF   NOT FO  THEN 12030
12042 FO =  VAL( RIGHT$(ID$(FO),4))
12045  GOSUB 12300: REM  GET IT
12050  GOSUB 12400: REM  DISPLAY
12055  VTAB 23: CALL  -868: INPUT "HIT RETURN WHEN READY TO CONTINUE : ";RE$
12099  GOTO 12030
12100  REM  *** GET A RECORD#
12125  VTAB 23: CALL  -868: INPUT "WHAT IS THE RECORD IDENTIFIER : ";RE$
12126  IF RE$ = ""  THEN  RETURN 
12130  IF  LEN(RE$) > VAL(FL$(1))  THEN  VTAB 23: CALL  -868: PRINT "THE RECORD NUMBER IS " VAL(FL$(1))" CHARACTERS LONG": FOR PA = 1 TO 1000: NEXT PA: GOTO 12125
12135  IF  LEN(RE$) < VAL(FL$(1))  THEN RE$ =  LEFT$("000000", VAL(FL$(1)) - LEN(RE$)) +RE$
12195  RETURN 
12200  REM  *** FIND THE RECORD
12222 FOUND = FALSE
12224  IF NI <1  THEN 12240
12225  FOR I = 1 TO NI
12227  IF  LEFT$(ID$(I),1) = "/"  THEN 12235
12230  IF  MID$ (ID$(I),2, VAL(FL$(1))) = RE$  THEN FOUND = I: GOTO 12240
12235  NEXT 
12240  IF   NOT FOUND  THEN  VTAB 23: CALL  -868: PRINT "THAT RECORD IS NOT ON FILE": FOR PA = 1 TO 1000: NEXT PA
12299  RETURN 
12300  REM  *** GET THE RECORD
12315  REM  *** FROM THE DISK
12327  PRINT DOS$"OPEN "F$"@DATA,L"RL +1
12330  PRINT DOS$"READ "F$"@DATA,R"FOUND
12335  INPUT RE$: REM  GET WHOLE INFO
12340 TMP = 1: FOR I = 1 TO NF
12345 RE$(I) =  MID$ (RE$,TMP, VAL(FL$(I))):TMP = TMP + VAL(FL$(I))
12350  NEXT I
12355  PRINT DOS$"CLOSE "F$"@DATA"
12399  RETURN 
12400  REM  *** DISPLAY THE REC
12425  HOME : VTAB 1: PRINT "<<< DISPLAY OF RECORD "RE$(1)" >>>": VTAB 5
12430  FOR I = 1 TO NF
12435  PRINT FI$(I)": ";RE$(I)
12440  NEXT I
12499  RETURN 
12999  RETURN 
13000  REM  *** MODIFY RECORD
13030  GOSUB 12100: REM  GET REC#
13031  IF RE$ = ""  THEN  RETURN 
13035  GOSUB 12200: REM  FIND IT
13040  IF   NOT FO  THEN 13030
13042 IN = FO:FO =  VAL( RIGHT$(ID$(FO),4))
13045  GOSUB 12300: REM  GET IT
13050  GOSUB 13100: REM  MODIFY
13055  GOSUB 10300: REM  DISPLAY
13060  IF RE$ = "Y"  THEN  GOSUB 10400: REM  OUTPUT IT
13099  GOTO 13030
13100  REM  *** MODIFY THE REC
13122 RN = FOUND
13125  TEXT : HOME : VTAB 1
13130  PRINT "<<< MODIFYING RECORD "RN" >>>": VTAB 5
13135  FOR I = 1 TO NF
13140  PRINT FI$(I)": ";RE$(I);: FOR J = 1 TO  VAL(FL$(I)): PRINT  CHR$(8);: NEXT : INPUT "";RE$
13145  IF  LEN(RE$) > VAL(FL$(I))  THEN 13140
13147  IF RE$ = ""  THEN  VTAB ( PEEK(37)): CALL  -958: PRINT FI$(I)": "RE$(I): GOTO 13160
13150  IF  LEN(RE$) < VAL(FL$(I))  THEN RE$ = RE$ + LEFT$(BL$, VAL(FL$(I)) - LEN(RE$))
13155 RE$(I) = RE$
13160  NEXT 
13199  RETURN 
13999  RETURN 
14000  REM  *** LIST / PRINTER
14020  REM 
14022 PRNTR = (RE$ = "PRI"  OR RE$ = "DPR")
14023 DLTD = (RE$ = "DLI"  OR RE$ = "DPR")
14025  GOSUB 14100: REM  GET FLDS
14026  GOSUB 14600
14030  IF TP  THEN  GOSUB 14200: REM  DISPLAY FIELDS
14099  RETURN 
14100  REM  *** GET FIELDS TO BE
14112  REM  ***   DISPLAYED
14125  LET TP = 0
14130  VTAB 23: CALL  -868: INPUT "FIELD TO LIST (OR RETURN) : ";RE$
14132  IF RE$ = ""  THEN 14170
14135  FOR I = 1 TO NF
14140  IF RE$ = FI$(I)  THEN 14160
14145  NEXT I
14150  VTAB 23: CALL  -868: PRINT "THAT FIELD DOES NOT EXIST.": FOR PA = 1 TO 1000: NEXT PA: GOTO 14130
14160 TP = TP +1:TF(TP) = I
14165  IF TP <50  THEN 14130
14170  RETURN 
14200  REM  *** ACTUAL DISPLAY
14221  IF NI =  <1  THEN  RETURN 
14222  IF PRNTR  THEN  PRINT DOS$"PR#1": PRINT  CHR$(9)"80N"
14223 ERR = 0: IF   NOT ERR  THEN  PRINT DOS$"OPEN "F$"@DATA,L"RL +1: GOTO 14226
14224  VTAB 23: CALL  -958: PRINT "THERE IS NO MORE ROOM FOR DATA...": FOR PA = 1 TO 1000: NEXT PA: GOTO 14267
14226  GOSUB 14300: REM  DO TITLE
14227  FOR I = 1 TO NI
14230 FO =  VAL( RIGHT$(ID$(I),4)): GOSUB 14400: REM  GET AND DISSECT RECORD
14232  IF DLTD  AND  LEFT$(ID$(I),1) < >"/"  THEN 14260
14233  IF   NOT DLTD  AND  LEFT$(ID$(I),1) = "/"  THEN 14260
14235  FOR J = 1 TO TP
14240  PRINT RE$(TF(J))" ";
14245  NEXT J: PRINT 
14247  FOR J = 1 TO GT:GT(J,2) = GT(J,2) + VAL(RE$(GT(J,1))): NEXT J
14255  IF   NOT PRNTR  AND  PEEK(37) >20  THEN  GOSUB 14500
14260  NEXT I
14262  PRINT : IF   NOT GT  THEN  PRINT : PRINT : GOTO 14265
14263  GOSUB 14800: REM  TOTALS
14265  IF PRNTR  THEN  PRINT DOS$"PR#0"
14267  PRINT DOS$"CLOSE "F$"@DATA"
14270  VTAB 23: CALL  -868: INPUT "HIT RETURN WHEN READY TO CONTINUE : ";RE$
14299  RETURN 
14300  REM  *** PRINT TITLES
14322  IF VIDEO  THEN  TEXT : HOME : NORMAL 
14325 TMP = 1
14330  FOR J = 1 TO TP
14335 TMP$ = FI$(TF(J)):TMP =  VAL(FL$(TF(J)))
14340  IF  LEN(TM$) > = TM  THEN TM$ =  LEFT$(TM$,TM): GOTO 14350
14345 TM$ = TM$ + LEFT$(BL$,TM - LEN(TM$))
14350  PRINT TM$" ";: NEXT : PRINT : PRINT "^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^": PRINT 
14399  RETURN 
14400  REM  *** GET RECORDS FOR
14415  REM  *** LIST / PRINTING
14425  PRINT DOS$"READ "F$"@DATA,R"FOUND
14430  INPUT RE$: REM  GET WHOLE INFO
14435 TMP = 1: FOR J = 1 TO NF
14440 RE$(J) =  MID$ (RE$,TMP, VAL(FL$(J))):TMP = TMP + VAL(FL$(J))
14445  NEXT J
14450  PRINT DOS$
14455  RETURN 
14500  REM  *** PAUSE FOR DELAY
14525  VTAB 23: PRINT "S TO STOP, OR RETURN TO CONTINUE : ";: GET TMP$
14530  IF TMP$ = "S"  THEN  POP : RETURN 
14535  GOSUB 14300: REM  TITLES
14540  RETURN 
14600  REM  *** GET TOTAL FIELDS
14625  LET GT = 0
14630  VTAB 23: CALL  -868: INPUT "FIELD TO TOTAL (OR RETURN) : ";RE$
14635  IF RE$ = ""  THEN 14670
14640  FOR I = 1 TO NF: IF RE$ = FI$(I)  THEN 14660
14645  NEXT I
14650  VTAB 23: CALL  -868: PRINT "THAT FIELD DOES NOT EXIST.": FOR PA = 1 TO 1000: NEXT PA: GOTO 14630
14660 GT = GT +1:GT(GT,1) = I:GT(GT,2) = 0
14665  IF GT <50  THEN 14630
14670  RETURN 
14700  REM  *** FORMAT A STRING
14723 ZZ =  VAL(FL$(TFD(J)))
14725  IF XX <0  THEN XX =  ABS(XX): GOSUB 14730:XX$ = "-" + RIGHT$(XX$,ZZ -1): RETURN 
14730 XX$ =  RIGHT$("0000000000000000" + STR$( INT(XX +.005)) +"." + RIGHT$( STR$( INT((XX +100) *100 +.5)),2),ZZ +3)
14800  REM  DO TOTALS
14822  PRINT "TOTALS^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^"
14825 TMP = 1: FOR J = 1 TO TP
14830  FOR K = 1 TO GT: IF GT(K,1) < >TF(J)  THEN  NEXT : PRINT  LEFT$(BL$, VAL(FL$(TF(J))))" ";: GOTO 14840
14835 XX = GT(K,2): GOSUB 14700: PRINT XX$" ";
14840  NEXT J: PRINT : PRINT : PRINT : RETURN 
14999  RETURN 
15000  REM  *** RECOVER DELETED
15012  REM  ***    RECORD
15025  GOSUB 12100: REM  GET REC#
15030  IF RE$ = ""  THEN  RETURN 
15035  GOSUB 15100: REM  FIND IT
15040  IF FOUND  THEN  GOSUB 15200: REM  RECOVER IT
15099  GOTO 15025
15100  REM  *** FIND IT
15122 FOUND = FALSE
15124  IF NI <1  THEN 15140
15125  FOR I = 1 TO NI
15127  IF  LEFT$(ID$(I),1) = "/"  AND  MID$ (ID$(I),2, VAL(FL$(1))) = RE$  THEN FOUND = I: GOTO 15140
15135  NEXT 
15140  IF   NOT FOUND  THEN  VTAB 23: CALL  -868: PRINT "THAT RECORD IS NOT ON FILE": FOR PA = 1 TO 1000: NEXT PA
15199  RETURN 
15200  REM  *** RECOVER IT
15225 ID$(FO) = ">" + MID$ (ID$(FO),2):IN = FO: GOSUB 10460
15299  RETURN 
16000  REM  *** SHOW THE RECORD
16015  REM  ***    LAYOUT
16030  GOSUB 16100: REM  OUTPUT
16060  VTAB 23: CALL  -868: INPUT "HIT RETURN WHEN READY TO CONTINUE : ";RE$
16099  RETURN 
16100  REM  *** DISPLAY REC INFO
16125  TEXT : HOME : VTAB 1
16130  PRINT "<<< SHOWING THE RECORD LAYOUT >>>": VTAB 5
16135  FOR I = 1 TO NF
16140  PRINT FI$(I)": ";: FOR J = 1 TO  VAL(FL$(I)): PRINT  CHR$(95);: NEXT : HTAB 35: PRINT  VAL(FL$(I))
16150  NEXT 
16160  RETURN 
17000  REM  *** INITIALIZE
17025 ERR = 0: IF   NOT ERR  THEN  PRINT DOS$"OPEN "F$"@HEADER": GOTO 17030
17027  VTAB 23: CALL  -958: PRINT "THERE IS NO ROOM ON THIS DISK.": FOR PA = 1 TO 1000: NEXT PA: GOTO 4000: REM  ABORT !!!
17030  PRINT DOS$"READ "F$"@HEADER"
17035 ERR = FALSE: IF   NOT ERR  THEN  INPUT DUMMY$
17040  PRINT DOS$"CLOSE "F$"@HEADER"
17045  REM 
17050  IF ERR  THEN  PRINT  CHR$(4)"DELETE "F$"@HEADER": GOSUB 18000: REM  INIT
17055  RETURN 
18000  REM  *** DO INIT ROUTINE
18025  GOSUB 18900: REM  WANT TO?
18030  IF RE$ = "N"  THEN 4000: REM  BAIL-OUT ABORT METHOD
18035  GOSUB 18100: REM  DOIT !!!
18040  RETURN 
18100  REM  *** GET FIELD STUFF
18125  LET RL = 1: REM  RECORD LENGTH = DELCHAR + ...
18130  GOSUB 18200: REM  GET ENTRY
18135  IF XF$ < >""  THEN 18140
18137  IF NF >1  THEN  GOSUB 18500: RETURN : REM  WRITE TO FILE
18138  VTAB 23: CALL  -958: PRINT "AT LEAST ONE ITEM IS REQUIRED...": FOR PA = 1 TO 1000: NEXT PA: GOTO 18125
18140  IF RE$ = "Y"  THEN NF = NF +1:FI$(NF) = XF$:FL$(NF) = XL$:RL = RL + VAL(XL$)
18145  GOTO 18130
18200  REM  *** GET A FIELDNAME,
18215  REM  *** LENGTH AND STUFF
18230  IF VIDEO  THEN  TEXT : HOME : NORMAL 
18235  VTAB 1: PRINT "ENTER THE FOLLOWING INFORMATION : ": VTAB 5
18237  IF NF = 0  THEN  INPUT "ID (RETURN TO STOP) : ";XF$: GOTO 18242
18240  INPUT "FIELD NAME (RETURN TO STOP) : ";XF$
18242  IF XF$ = ""  THEN  RETURN 
18245  VTAB 6: CALL  -868: INPUT "FIELD LENGTH : ";XL$: IF  VAL(XL$) <1  THEN  PRINT "": GOTO 18245
18250  IF  VAL(XL$) +RL >245  THEN  VTAB 6: CALL  -868: PRINT "<<< RECORD LENGTH TOO LONG >>>": FOR PAUSE = 1 TO 1000: NEXT PAUSE: GOTO 18230
18285  VTAB 23: CALL  -868: INPUT "IS THIS CORRECT : ";RE$:RE$ =  LEFT$(RE$,1): IF RE$ < >"Y"  AND RE$ < >"N"  THEN  PRINT "";: GOTO 18285
18290  RETURN 
18500  REM  *** WRITE TO HEADER
18521  GOSUB 16100
18522  VTAB 23: CALL  -868: INPUT "IS THIS ALL CORRECT : ";RE$: IF  LEFT$(RE$,1) < >"Y"  AND  LEFT$(RE$,1) < >"N"  THEN 18522
18523  IF  LEFT$(RE$,1) = "N"  THEN 4000
18525  PRINT DOS$"OPEN "F$"@HEADER"
18530  PRINT DOS$"WRITE "F$"@HEADER"
18535  FOR I = 1 TO NF
18537 ERR = 0: IF   NOT ERR  THEN  PRINT FI$(I): IF   NOT ERR  THEN  PRINT FL$(I): GOTO 18539
18538  VTAB 23: CALL  -958: PRINT "THERE IS NO MORE ROOM FOR THIS HEADER": FOR PA = 1 TO 1000: NEXT PA: GOTO 4000: REM  BAIL OUT !!!
18539  NEXT 
18540  PRINT DOS$"CLOSE "F$"@HEADER"
18545  RETURN 
18900  REM  *** WANT TO DO IT?
18925  IF VIDEO  THEN  TEXT : HOME : NORMAL 
18930  VTAB 1: PRINT "*****   INITIALIZATION PROCEDURE   *****"
18935  VTAB 5: PRINT "   I'M SORRY, BUT THERE IS NO HEADER    FILE ON THIS DISK. INITIALIZATION MUST  BE DONE BEFORE ANY DATA CAN BE SAVED OR ACCESSED."
18940  PRINT : INPUT "DO YOU WISH TO INITIALIZE A DATA FILE ONTHE CURRENT DISKETTE? ";RESPNSE$
18945  IF  LEFT$(RE$,1) = "Y"  OR  LEFT$(RE$,1) = "N"  THEN RE$ =  LEFT$(RE$,1): RETURN 
18950  PRINT : PRINT "PLEASE ANSWER 'YES' OR 'NO'.": GOTO 18940
19000  REM  *** SORT ROUTINE
19025  HOME : VTAB 10: PRINT "***  SORT IN PROGRESS, DO NOT TOUCH  ***"
19030  GOSUB 19100: REM  SORT THE INDEXES IN MEMORY
19035  GOSUB 19200: REM  OUTPUT THE SORTED INDEXES
19040  RETURN 
19100  REM  *** SORT BY INDEX
19125 I = 0
19130 I = I +1
19135  IF ID$(I) <ID$(I +1)  THEN 19170
19140 TMP$ = ID$(I):ID$(I) = ID$(I +1):ID$(I +1) = TMP$
19145 J = I -1: IF J <1  THEN J = 1
19150  IF ID$(J) <ID$(J +1)  THEN 19135
19155 TMP$ = ID$(J):ID$(J) = ID$(J +1):ID$(J +1) = TMP$
19160 J = J -1: IF J <1  THEN J = 1
19165  GOTO 19150
19170  IF I <NI -1  THEN 19130
19175  RETURN 
19200  REM  *** OUTPUT INDEXES
19225  IF TESTING  THEN  PRINT "INDEXES OUTPUT..."
19230  PRINT DOS$"OPEN "F$"@INDEXES,L"IL
19235  PRINT DOS$"WRITE "F$"@INDEXES,R1"
19240  FOR I = 1 TO NI: PRINT ID$(I): NEXT 
19245  PRINT DOS$"CLOSE "F$"@INDEXES"
19250  RETURN 
20000  REM  *** SEARCH FOR A REC
20025  GOSUB 20100: REM  FIELD
20026  IF RE$ = ""  THEN  RETURN 
20027  IF   NOT RI  THEN  RETURN 
20030  GOSUB 20200: REM  ALL?
20035  GOSUB 20300: REM  CNSTNT
20037  IF RE$ = ""  THEN  RETURN 
20040  GOSUB 20400: REM  DO IT
20090  GOTO 20025
20100  REM  *** GET NEEDED FIELD
20125  VTAB 23: CALL  -868: INPUT "FIELD TO SEARCH ON : ";RE$
20130  IF RE$ = ""  THEN  RETURN 
20135  FOR RI = 1 TO NF
20140  IF RE$ = FI$(RI)  THEN 20155
20145  NEXT 
20150  VTAB 23: CALL  -868: PRINT "THAT FIELD DOES NOT EXIST.": FOR PA = 1 TO 1000: NEXT PA:RI = 0: RETURN 
20155  RETURN 
20200  REM  *** 2 OR ALL CHARS
20225  VTAB 23: CALL  -868: INPUT "ALL CHARACTER MATCH OR FIRST TWO : ";ALL$
20230 ALL$ =  LEFT$(ALL$,1): IF ALL$ = "A"  OR ALL$ = "A"  OR ALL$ = "F"  OR ALL$ = "F"  THEN  RETURN 
20235  VTAB 23: CALL  -868: PRINT "TYPE 'A' OR 'F' PLEASE.": FOR PA = 1 TO 1000: NEXT PA: GOTO 20225
20300  REM  *** GET CONSTANT
20325  VTAB 23: CALL  -868: INPUT "WHAT IS THE CONSTANT : ";RC$
20327  IF RC$ = ""  THEN  RETURN 
20330 R2$ =  LEFT$(RC$ +" ",2)
20335  IF  LEN(RC$) < VAL(FL$(RI))  THEN RC$ = RC$ + LEFT$(BL$, VAL(FL$(RI)) - LEN(RC$))
20340  IF  LEN(RC$) > VAL(FL$(RI))  THEN  VTAB 23: CALL  -868: PRINT "THE FIELD IS "FL$(RI)" CHARS LONG.": FOR PA = 1 TO 1000: NEXT :RC$ = ""
20345  IF RI = 1  THEN R2$ = RC$
20390  RETURN 
20400  REM  *** DO THE SEARCH
20422 ST = 1
20425  GOSUB 20500: REM  FIRST MATCH
20430  IF   NOT FO  THEN  RETURN 
20435  GOSUB 20600: REM  SECOND MATCH
20440  IF   NOT FO  THEN 20425
20450  GOSUB 12400: REM  DISPLAY
20455  GOSUB 20700: REM  INPUT
20460  GOTO 20425
20500  REM  *** GET NEXT MATCH
20522 R2 =  VAL(FL$(I)) +(2 *(RI -1)): IF RI = 1  THEN R2 = 2
20523 RT =  VAL(FL$(RI)): IF RI >1  THEN RT = 2
20524  IF ST >NI  THEN 20590
20525  FOR I = ST TO NI
20527 RT$ =  MID$ (ID$(I),R2,RT)
20535  IF RT$ = R2$  THEN FOUND =  VAL( RIGHT$(ID$(I),4)): GOTO 20595
20540  NEXT I
20590 FOUND = FALSE
20595 ST = I +1: RETURN 
20600  REM  *** GET RECORD/MATCH
20625  GOSUB 12300: REM  GET REC
20630  IF RE$(RI) = RC$  THEN FOUND = TRUE: RETURN 
20632  IF ALL$ = "F"  OR ALL$ = "F"  THEN FOUND = TRUE: RETURN 
20635 FOUND = FALSE: RETURN 
20700  REM  *** CONTINUE ?
20725  VTAB 23: HTAB 1: CALL  -868: PRINT "S TO STOP, OR RETURN TO CONTINUE : ";: GET TMP$
20730  IF TMP$ = "S"  OR TMP$ = "S"  THEN  POP : POP : RETURN 
20735  IF TMP$ =  CHR$(13)  THEN  PRINT : RETURN 
20740  GOTO 20725
30000  REM  *** ERROR RECOVERY
30015  REM  *** ROUTINES
30030 ERR =  PEEK(222)
30035  IF ERR = 5  THEN  RESUME : REM  * JUST AN END OF FILE *
30040  IF ERR = 9  THEN  RESUME : REM  * JUST A DISK FULL *
30045  IF ERR = 4  THEN  VTAB 23: CALL  -958: PRINT "THE DISK IS WRITE PROTECTED": FOR PA = 1 TO 1000: NEXT PA: GOTO 4000
30050  IF ERR = 8  THEN  VTAB 23: CALL  -958: PRINT "THE DISK HAD AN I/O ERROR": FOR PA = 1 TO 1000: NEXT PA: GOTO 4000
30055  IF ERR = 10  THEN  VTAB 23: CALL  -958: PRINT "A FILE IS LOCKED AND SHOULD NOT BE": FOR PA = 1 TO 1000: NEXT PA: GOTO 4000
30100  REM  *** UNEXPECTED ERROR
30125  IF VIDEO  THEN  TEXT : HOME : NORMAL 
30130  IF TESTING  THEN  POKE 216,0: PRINT "**** ERROR ****": RESUME 
30133  IF ERR = 255  THEN  PRINT "OPERATOR ABORT...": END 
30135  REM 
30140  REM  GOSUB 4000:REM SHUTDOWN
30145  REM 
30150  VTAB 3: PRINT "   I'M SORRY, BUT AN UNEXPECTED ERROR   HAS OCCURED DURING PROGRAM EXECUTION.   IT WOULD BE WISE AT THIS TIME TO RESTOREYOUR FILE WITH A BACKUP FILE."
30155 X =  PEEK(218) + PEEK(219) *256: PRINT : PRINT "ERROR WAS IN LINE #";X
30157 ERR =  PEEK(222): PRINT "ERROR #";ERR
30160  END 